#!/bin/bash
#SBATCH -p cpu
#SBATCH -t 1-00:00:00

proc=$2;
echo $proc


case $1 in

    mpi)
    mpirun -np $proc ./dfm-potm_mpi.out input_param.dat
    ;;

    openmp)
    #SBATCH -c $proc
    export OMP_NUM_THREADS=$proc  
    export OMP_PLACES=cores
    ./dfm-potm_openmp.out input_param.dat
    ;;

    serial)
    #SBATCH -n 1
    ./dfm-potm_serial.out input_param.dat
    ;;

    *)
    echo "Wrong input parameters"
    ;;
esac
exit
