// pa_U_0.cpp : Defines the entry point for the console application.
//

// #include "stdafx.h"
#include "math.h"
#include <stdio.h>
// #include "conio.h"
// #include "ctype.h"
//#include "mpi.h"
#include "omp.h"
// #include "limits.h"

// #include <random>

#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <sstream>
#define MAXLEN 80
using namespace std;

struct sample_parameters
{
  char i_n[MAXLEN];
  char i_En[MAXLEN];
  char i_AA1[MAXLEN];
  char i_ZZ1[MAXLEN];
  char i_AA2[MAXLEN];
  char i_ZZ2[MAXLEN];
}
  sample_parameters;
  
 

/*
 * initialize data to default values
 */
void
init_parameters (struct sample_parameters * parms)
{
  strncpy (parms->i_n, "-25", MAXLEN);
  strncpy (parms->i_En, "-25", MAXLEN);
  strncpy (parms->i_AA1, "-25", MAXLEN);
  strncpy (parms->i_ZZ1, "-25", MAXLEN);
  strncpy (parms->i_AA2, "-25", MAXLEN);
  strncpy (parms->i_ZZ2, "-25", MAXLEN);
 
}

/*
 * trim: get rid of trailing and leading whitespace...
 *       ...including the annoying "\n" from fgets()
 */
char *
trim (char * s)
{
  /* Initialize start, end pointers */
  char *s1 = s, *s2 = &s[strlen (s) - 1];

  /* Trim and delimit right side */
  while ( (isspace (*s2)) && (s2 >= s1) )
    s2--;
  *(s2+1) = '\0';

  /* Trim left side */
  while ( (isspace (*s1)) && (s1 < s2) )
    s1++;

  /* Copy finished string */
  strcpy (s, s1);
  return s;
}

/*
 * parse external parameters file
 *
 * NOTES:
 * - There are millions of ways to do this, depending on your
 *   specific needs.
 *
 * - In general:
 *   a) The client will know which parameters it's expecting
 *      (hence the "struct", with a specific set of parameters).
 *   b) The client should NOT know any specifics about the
 *      configuration file itself (for example, the client
 *      shouldn't know or care about it's name, its location,
 *      its format ... or whether or not the "configuration
 *      file" is even a file ... or a database ... or something
 *      else entirely).
 *   c) The client should initialize the parameters to reasonable
 *      defaults
 *   d) The client is responsible for validating whether the
 *      pararmeters are complete, or correct.
 */
void
parse_config (struct sample_parameters * parms, char * fl)
{
  char *s, buff[256];
  FILE *fp = fopen (fl, "r");
  if (fp == NULL)
  {
    return;
  }

  /* Read next line */
  while ((s = fgets (buff, sizeof buff, fp)) != NULL)
  {
    /* Skip blank lines and comments */
    if (buff[0] == '\n' || buff[0] == '#')
      continue;

    /* Parse name/value pair from line */
    char name[MAXLEN], value[MAXLEN];
    s = strtok (buff, "=");
    if (s==NULL)
      continue;
    else
      strncpy (name, s, MAXLEN);
    s = strtok (NULL, "=");
    if (s==NULL)
      continue;
    else
      strncpy (value, s, MAXLEN);
    trim (value);

    /* Copy into correct entry in parameters struct */
    if (strcmp(name, "n")==0)
      strncpy (parms->i_n, value, MAXLEN);
    else if (strcmp(name, "En")==0)
      strncpy (parms->i_En, value, MAXLEN);
    else if (strcmp(name, "AA1")==0)
      strncpy (parms->i_AA1, value, MAXLEN);
  else if (strcmp(name, "ZZ1")==0)
      strncpy (parms->i_ZZ1, value, MAXLEN);
  else if (strcmp(name, "AA2")==0)
      strncpy (parms->i_AA2, value, MAXLEN);
  else if (strcmp(name, "ZZ2")==0)
      strncpy (parms->i_ZZ2, value, MAXLEN);
    else
      printf ("WARNING: %s/%s: Unknown name/value pair!\n",
        name, value);
  }

  /* Close file */
  fclose (fp);
}



//------------------------------
int main(int argc, char *argv[])

//---------------------------------------
{
	double rmin,rmax,h,r,k,s,t,u,ccc,alphaa,betaa,gammaa,En,E,pi,AA1,AA2,ZZ1,ZZ2,kr,fr1,fr2,rr,uuj,pi4,CCCs,tx,ty;
	int i,j,m,l,ll,n = 0;//n=201
	FILE *stream;
	char mys[255];
	char str[50];

	struct sample_parameters parms;
	char * fl=argv[1];
	
	printf ("Initializing parameters to default values...\n");
	init_parameters (&parms);
	
	printf ("Reading config file...\n");
	parse_config (&parms,fl);

// ?????????????????? rmin,rmax
	rmin=0.01;
	rmax=10.01000;
	n=atoi(parms.i_n);
	h=(rmax-rmin)/(n-1);
	
	


// ?????????????? ?????? u0d
	double *rho1_podint=NULL, *rho2_podint=NULL, *rho1=NULL, *rho2=NULL;
	double *rho1c_podint=NULL,*rho2c_podint=NULL,*rho1c=NULL,*rho2c=NULL;
	double *rho1t_podint=NULL,*rho2t_podint=NULL,*rho1t=NULL,*rho2t=NULL;
	double *v00d_podint=NULL,*v00d=NULL;
	double *u0d_podint=NULL,*u0d=NULL;

//	27/11/2003 - ?????????????????????? - ?????????????????????????????? ???????????? ???????????????? ?????????????? ????????????????????.
	double *data_fun_rho1=NULL,*data_fun_rho2=NULL;


// ?????????????? ?????? u0ex
	double *d_rho1_d_r=NULL,*d_rho2_d_r=NULL;
	double *d2_rho1_d_r2=NULL,*d2_rho2_d_r2=NULL;
	double *Kav_a_1=NULL,*Kav_a_2=NULL;
	double *Kav_b_1=NULL,*Kav_b_2=NULL;
	double *u0ex=NULL,*u0ex_podint=NULL;
	double *v00ex=NULL,*v00ex_podint=NULL;
	double *G_big=NULL,*G_big_podint=NULL;
	double *G_alpha=NULL,*G_gamma=NULL;
	double *h1=NULL,*h2=NULL,*h1_podint=NULL,*h2_podint=NULL;
	double *y1=NULL,*y2=NULL,*y1_podint=NULL,*y2_podint=NULL;
	double *z1_1=NULL,*z1_2=NULL,*z2_1=NULL,*z2_2=NULL;
	double *z1_1_podint=NULL,*z1_2_podint=NULL,*z2_1_podint=NULL,*z2_2_podint=NULL;

	//?????????????? ?????? ???????????? 
	double *Kav_a_1V=NULL,*Kav_a_2V=NULL;
	double *Kav_b_1V=NULL,*Kav_b_2V=NULL;
	double *u0ex_podintV=NULL;
	double *G_bigV=NULL;
	double *v00exV=NULL;

// ??????????????
	double simpson(double h, int n, double *f);
	double fun_rho1(double r_mal);
	double fun_rho2(double r_mal);
	double jjj0(double x);
	double jjj1(double x);
	double fun_K(double A1, double A2, double Z1, double Z2, double r, double En, double U);
	
	
	


	En=atof(parms.i_En);
	AA1=atof(parms.i_AA1);
	ZZ1=atof(parms.i_ZZ1);
	
	E=En*AA1;
	
	AA2=atof(parms.i_AA2);
	ZZ2=atof(parms.i_ZZ2);


//
	pi=2.0*asin(1.0);
	pi4 = pi*4.000;




	ccc=0.2658;
	alphaa=3.8033;
	betaa=1.4099;
	gammaa=4.0;
	CCCs=0.25;

	//???????????????????? ?????? ?????????????? ??????????????
	double starttime, endtime; 
	/// ?????????????????? ???????????????????? ?????? ????????????????????????????????????--------------------------------------------------------
	int  count, start, stop;
	int nloops;
	int rank = 0;
	int size = 0;
    int reduce1;
	//???????????????? ?????????????? ?????? ????????????????
	double *rho1V=NULL, *rho2V=NULL, *rho1cV=NULL, *rho2cV=NULL, *rho1tV=NULL, *rho2tV=NULL, *v00dV=NULL;
	
	
	
	rho1=(double*)malloc(n*sizeof(double)); rho2=(double*)malloc(n*sizeof(double));
	 rho1c=(double*)malloc(n*sizeof(double)); rho2c=(double*)malloc(n*sizeof(double));
	rho1t=(double*)malloc(n*sizeof(double));rho2t=(double*)malloc(n*sizeof(double));
	 v00d=(double*)malloc(n*sizeof(double));
	u0d=(double*)malloc(n*sizeof(double));


	data_fun_rho1=(double*)malloc(n*sizeof(double));data_fun_rho2=(double*)malloc(n*sizeof(double));



	d_rho1_d_r=(double*)malloc(n*sizeof(double)); d_rho2_d_r=(double*)malloc(n*sizeof(double));
	d2_rho1_d_r2=(double*)malloc(n*sizeof(double));d2_rho2_d_r2=(double*)malloc(n*sizeof(double));
	Kav_a_1=(double*)malloc(n*sizeof(double)); Kav_a_2=(double*)malloc(n*sizeof(double));
	Kav_b_1=(double*)malloc(n*sizeof(double)); Kav_b_2=(double*)malloc(n*sizeof(double));
	u0ex=(double*)malloc(n*sizeof(double)); u0ex_podint=(double*)malloc(n*sizeof(double));
	v00ex=(double*)malloc(n*sizeof(double)); v00ex_podint=(double*)malloc(n*sizeof(double));
	G_big=(double*)malloc(n*sizeof(double));
	


	Kav_a_1V=(double*)malloc(n*sizeof(double)); Kav_a_2V=(double*)malloc(n*sizeof(double));
	Kav_b_1V=(double*)malloc(n*sizeof(double)); Kav_b_2V=(double*)malloc(n*sizeof(double));
	u0ex_podintV=(double*)malloc(n*sizeof(double));
	G_bigV=(double*)malloc(n*sizeof(double));
	v00exV=(double*)malloc(n*sizeof(double));
	
	rho1V=(double*)malloc(n*sizeof(double)); rho2V=(double*)malloc(n*sizeof(double)); rho1cV=(double*)malloc(n*sizeof(double)); rho2cV=(double*)malloc(n*sizeof(double)); rho1tV=(double*)malloc(n*sizeof(double));
	rho2tV=(double*)malloc(n*sizeof(double)); v00dV=(double*)malloc(n*sizeof(double));
	
	
	
	
	
	///--------------------------------------------------------
// 27/11/2003 - ?????????????????????? - ?????????????????????????????? ???????????? ?????????????? ????????????????????
	for (j=0;j<n;j++) 
	{
		k=rmin+h*j;
		//---
		data_fun_rho1[j]=fun_rho1(k);
		data_fun_rho2[j]=fun_rho2(k);
	}
 
  
   for(i = 0; i< n ; i++)
   {
	     	rho1[i] = 0;
			rho2[i] = 0;
			rho1c[i] = 0;
			rho2c[i] = 0;
			rho1t[i] = 0;
			rho2t[i] = 0;
			v00d[i] = 0;
   }
  

	starttime= omp_get_wtime();
	// ?????????????? ???????????????????????? 5.14,5.15,5.16

		
		#pragma omp parallel private (i,j,fr1,fr2,r,rr,kr,k,rho1_podint,rho2_podint,rho1c_podint,rho2c_podint,rho1t_podint,rho2t_podint,v00d_podint)
		{
			rho1_podint=(double*)malloc(n*sizeof(double)); rho2_podint=(double*)malloc(n*sizeof(double));
			rho1c_podint=(double*)malloc(n*sizeof(double)); rho2c_podint=(double*)malloc(n*sizeof(double));
			rho1t_podint=(double*)malloc(n*sizeof(double)); rho2t_podint=(double*)malloc(n*sizeof(double));
			v00d_podint=(double*)malloc(n*sizeof(double));
			#pragma omp for
				for(j=0;j<n;j++)
				{
					k=rmin+h*j;
					for (i=0;i<n;i++) 
					{
						r=rmin+h*i;
						rr = r*r;
						kr=k*r;
						fr1=data_fun_rho1[i];
						fr2=data_fun_rho2[i];
						rho1_podint[i] =rr*fr1*jjj0(kr);
						rho2_podint[i] =rr*fr2*jjj0(kr);
						rho1c_podint[i]=rr*fr1*jjj0(kr)*exp(-1.0*betaa*fr1);
						rho2c_podint[i]=rr*fr2*jjj0(kr)*exp(-1.0*betaa*fr2);
						rho1t_podint[i]=rr*fr1*fr1*jjj0(kr);
						rho2t_podint[i]=rr*fr2*fr2*jjj0(kr);
	
						v00d_podint[i] =rr*jjj0(kr)*(11061.625*exp(-4.0*r)/(r*4.0) - 2537.5*exp(-2.5*r)/(r*2.5));
					}
			
					rho1V[j] = pi4*simpson(h,n,rho1_podint);
					rho2V[j] = pi4*simpson(h,n,rho2_podint);
					rho1cV[j] = pi4*simpson(h,n,rho1c_podint);
					rho2cV[j] = pi4*simpson(h,n,rho2c_podint);
					rho1tV[j] = pi4*simpson(h,n,rho1t_podint);
					rho2tV[j] = pi4*simpson(h,n,rho2t_podint);
					v00dV[j] = pi4*simpson(h,n,v00d_podint);	
			
				}
			free(rho1_podint); free(rho2_podint);
			free (rho1c_podint);free(rho2c_podint);
			free(rho1t_podint); free(rho2t_podint);
			free(v00d_podint);
		}
	
// ?????????????? ???????????? ?????????? U0D 5.13
	#pragma omp parallel private (i,r,j,k,kr,u0d_podint)
	{
		u0d_podint=(double*)malloc(n*sizeof(double));
		#pragma omp for
			for (i=0; i<n; i++)
			{
				r=rmin+h*i;
				for (j = 0; j < n; j++) 
				{
					k=rmin+h*j;
					kr=k*r;
			
					u0d_podint[j]=k*k*jjj0(kr)*( rho1V[j]*rho2V[j] + alphaa*rho1cV[j]*rho2cV[j] - gammaa*(rho1tV[j]*rho2V[j]+rho1V[j]*rho2tV[j]))*v00dV[j];
	
				}
		u0d[i]=simpson(h,n,u0d_podint)*(1.0-0.003*En)*ccc/(pi*pi*2.0);

			}
		free(u0d_podint);
	}
	

// ???????????? U0D ??????????????????. ?????????????????? ?? U0EX

	    // ???????????? Kav_a_1 ?? Kav_a_2 (5.29); Kav_b_1 ?? Kav_b_2 (5.30)
		d_rho1_d_r[0]=(-3*data_fun_rho1[0]+4*data_fun_rho1[1]-data_fun_rho1[2])/2/h;
		d_rho2_d_r[0]=(-3*data_fun_rho2[0]+4*data_fun_rho2[1]-data_fun_rho2[2])/2/h;
		d_rho1_d_r[n-1]=(data_fun_rho1[n-3]-4*data_fun_rho1[n-2]+3*data_fun_rho1[n-1])/2/h;
		d_rho2_d_r[n-1]=(data_fun_rho2[n-3]-4*data_fun_rho2[n-2]+3*data_fun_rho2[n-1])/2/h;

		for (i=1;i<(n-1);i++) 
		{
			d_rho1_d_r[i]=(data_fun_rho1[i+1]-data_fun_rho1[i-1])/2/h;
			d_rho2_d_r[i]=(data_fun_rho2[i+1]-data_fun_rho2[i-1])/2/h;
		}

		d2_rho1_d_r2[0]=(-3*d_rho1_d_r[0]+4*d_rho1_d_r[1]-d_rho1_d_r[2])/2/h;
		d2_rho2_d_r2[0]=(-3*d_rho2_d_r[0]+4*d_rho2_d_r[1]-d_rho2_d_r[2])/2/h;
		d2_rho1_d_r2[n-1]=(d_rho1_d_r[n-3]-4*d_rho1_d_r[n-2]+3*d_rho1_d_r[n-1])/2/h;
		d2_rho2_d_r2[n-1]=(d_rho2_d_r[n-3]-4*d_rho2_d_r[n-2]+3*d_rho2_d_r[n-1])/2/h;

		for (i=1;i<(n-1);i++)
		{
			d2_rho1_d_r2[i] = (d_rho1_d_r[i+1]-d_rho1_d_r[i-1])/2.0/h;
			d2_rho2_d_r2[i] = (d_rho2_d_r[i+1]-d_rho2_d_r[i-1])/2.0/h;
		
		}

	//}
		
	
		//-----------------
	for(int i=0; i<n; i++)
	{
            Kav_a_1V[i] = 0;
			Kav_a_2V[i] = 0;
			Kav_a_1[i] = 0;
			Kav_a_2[i] = 0;
	}
	
		
	
		#pragma omp parallel private (i,r)
		{
			#pragma omp parallel for
				for (i=0;i<n;i++)
				{
					r=rmin+h*i;
					Kav_a_1[i] =sqrt( fabs ( pow((3.0*pi*pi*data_fun_rho1[i]),0.66666) + 1.6667*CCCs*pow(d_rho1_d_r[i],2)/pow(data_fun_rho1[i],2) + 0.13888*(d2_rho1_d_r2[i]+2.0*d_rho1_d_r[i]/r)/data_fun_rho1[i] ) );
					Kav_a_2[i] =sqrt( fabs ( pow((3.0*pi*pi*data_fun_rho2[i]),0.66666) + 1.6667*CCCs*pow(d_rho2_d_r[i],2)/pow(data_fun_rho2[i],2) + 0.13888*(d2_rho2_d_r2[i]+2.0*d_rho2_d_r[i]/r)/data_fun_rho2[i] ) );
		
				}
		}




// ?????????????? u0ex ?? rmin - ?????????????????? ?????????????????????? 5.35 - 5.41
	r=rmin;
	
	 for(int k = 0; k < n; k++)
          {
	           u0ex_podintV[k] = 0;
			   G_big[k] = 0;
			   G_bigV[k] = 0;
			   v00exV[k] = 0;
			   v00ex[k] = 0;
          }	
	

	#pragma omp parallel private (i,j,m,s,t,u,uuj,y1_podint,y2_podint,z1_1_podint,z1_2_podint,z2_1_podint,z2_2_podint,h1_podint,h2_podint,y1,y2,z1_1,z1_2,z2_1,z2_2,G_alpha,G_gamma,h1,h2,G_big_podint)
	{
		h1=(double*)malloc(n*sizeof(double)); h2=(double*)malloc(n*sizeof(double)); h1_podint=(double*)malloc(n*sizeof(double)); h2_podint=(double*)malloc(n*sizeof(double));
		y1=(double*)malloc(n*sizeof(double)); y2=(double*)malloc(n*sizeof(double)); y1_podint=(double*)malloc(n*sizeof(double)); y2_podint=(double*)malloc(n*sizeof(double));
		z1_1=(double*)malloc(n*sizeof(double)); z1_2=(double*)malloc(n*sizeof(double)); z2_1=(double*)malloc(n*sizeof(double)); z2_2=(double*)malloc(n*sizeof(double));
		z1_1_podint=(double*)malloc(n*sizeof(double)); z1_2_podint=(double*)malloc(n*sizeof(double)); z2_1_podint=(double*)malloc(n*sizeof(double)); z2_2_podint=(double*)malloc(n*sizeof(double));
		G_big_podint=(double*)malloc(n*sizeof(double));
		G_alpha=(double*)malloc(n*sizeof(double));G_gamma=(double*)malloc(n*sizeof(double));
		
		#pragma omp for
		for (j=0;j<n;j++)
		{

			s=rmin+h*j;
			for (int i=0; i<n; i++) 
			{
				t=i*h+rmin;
				for (m=0;m<n;m++)
				{
					u=rmin+m*h;
					uuj = u*u*jjj0(t*u);
					y1_podint[m]=uuj*exp(-betaa*data_fun_rho1[m])*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
					y2_podint[m]=uuj*exp(-betaa*data_fun_rho2[m])*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
					z1_1_podint[m]=uuj*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
					z1_2_podint[m]=uuj*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
					z2_1_podint[m]=uuj*data_fun_rho1[m]*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
					z2_2_podint[m]=uuj*data_fun_rho2[m]*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
					h1_podint[m]=uuj*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
					h2_podint[m]=uuj*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
				}
				y1[i]=simpson(h,n,y1_podint)*pi4;
				y2[i]=simpson(h,n,y2_podint)*pi4;
				z1_1[i]=simpson(h,n,z1_1_podint)*pi4;
				z1_2[i]=simpson(h,n,z1_2_podint)*pi4;
				z2_1[i]=simpson(h,n,z2_1_podint)*pi4;
				z2_2[i]=simpson(h,n,z2_2_podint)*pi4;
				G_alpha[i]=y1[i]*y2[i];
				G_gamma[i]=z2_1[i]*z1_2[i]+z1_1[i]*z2_2[i];
				h1[i]=simpson(h,n,h1_podint)*pi4;
				h2[i]=simpson(h,n,h2_podint)*pi4;
				G_big_podint[i] = t*t*jjj0(r*t)*(h1[i]*h2[i]+alphaa*G_alpha[i]-gammaa*G_gamma[i]);



			}
			G_bigV[j]=simpson(h,n,G_big_podint)*ccc/2.0/pi/pi;

			v00exV[j]=-1524.25*exp(-4.0*s)/4./s - 518.75*exp(-2.5*s)/2.5/s - 7.8474*exp(-0.7072*s)/0.7072/s;

			u0ex_podint[j] = s*s*G_big[j]*jjj0(fun_K(AA1,AA2,ZZ1,ZZ2,r,En,u0d[0])*s*(AA1+AA2)/AA1/AA2)*v00ex[j];

	
		}
		free(G_big_podint);
		free (G_alpha); free(G_gamma);
		free (h1); free(h2);free(h1_podint);free(h2_podint);
		free (y1); free(y2);free (y1_podint); free(y2_podint);
		free (z1_1); free(z1_2); free(z2_1); free(z2_2);
		free (z1_1_podint); free(z1_2_podint);free(z2_1_podint); free(z2_2_podint);
	}
	
// ???????????????? ???????????? ?????????????????????? U0EX[0] 5.34
	u0ex[0]=simpson(h,n,u0ex_podint)*pi4*(1.0-0.003*En);

// ???????????????? U0EX[0]
	for(i=0;i<30;i++)
	{
	for(j=0;j<n;j++) 
		{
			s=h*j+rmin;
			u0ex_podint[j]=s*s*G_bigV[j]*jjj0(fun_K(AA1,AA2,ZZ1,ZZ2,r,En,u0d[0]+u0ex[0])*s*(AA1+AA2)/AA1/AA2)*v00exV[j];
		
		}	
	u0ex[0]=simpson(h,n,u0ex_podint)*pi4*(1.0-0.003*En);

	}


// ?????????????? u0ex ?? ?????????????????? ????????????;
	for (l=1;l<n;l++) {
	r=rmin+l*h;
   

	 for( i = 0; i < n; i++)
     {
	 u0ex_podintV[i] = 0;
     }
	

	#pragma omp parallel private (j,s,i,t,m,u,uuj,y1_podint,y2_podint,z1_1_podint,z1_2_podint,z2_1_podint,z2_2_podint,h1_podint,h2_podint,y1,y2,z1_1,z1_2,z2_1,z2_2,G_alpha,G_gamma,h1,h2,G_big_podint)
	{
		h1=(double*)malloc(n*sizeof(double)); h2=(double*)malloc(n*sizeof(double)); h1_podint=(double*)malloc(n*sizeof(double)); h2_podint=(double*)malloc(n*sizeof(double));
		y1=(double*)malloc(n*sizeof(double)); y2=(double*)malloc(n*sizeof(double)); y1_podint=(double*)malloc(n*sizeof(double)); y2_podint=(double*)malloc(n*sizeof(double));
		z1_1=(double*)malloc(n*sizeof(double)); z1_2=(double*)malloc(n*sizeof(double)); z2_1=(double*)malloc(n*sizeof(double)); z2_2=(double*)malloc(n*sizeof(double));
		z1_1_podint=(double*)malloc(n*sizeof(double)); z1_2_podint=(double*)malloc(n*sizeof(double)); z2_1_podint=(double*)malloc(n*sizeof(double)); z2_2_podint=(double*)malloc(n*sizeof(double));
		G_big_podint=(double*)malloc(n*sizeof(double));
		G_alpha=(double*)malloc(n*sizeof(double));G_gamma=(double*)malloc(n*sizeof(double));
		
		#pragma omp for
				for (j=0;j<n;j++)
				{

					s=rmin+h*j;
					for (i=0;i<n;i++) {
						t=i*h+rmin;
						for (m=0;m<n;m++) {
							u=rmin+m*h;
							uuj = u*u*jjj0(t*u);
							y1_podint[m]=uuj*exp(-betaa*data_fun_rho1[m])*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
							y2_podint[m]=uuj*exp(-betaa*data_fun_rho2[m])*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
							z1_1_podint[m]=uuj*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
							z1_2_podint[m]=uuj*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
							z2_1_podint[m]=uuj*data_fun_rho1[m]*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
							z2_2_podint[m]=uuj*data_fun_rho2[m]*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
							h1_podint[m]=uuj*data_fun_rho1[m]*jjj1(s*Kav_a_1[m]);
							h2_podint[m]=uuj*data_fun_rho2[m]*jjj1(s*Kav_a_2[m]);
						}			
						y1[i]=simpson(h,n,y1_podint)*pi4;
						y2[i]=simpson(h,n,y2_podint)*pi4;
						z1_1[i]=simpson(h,n,z1_1_podint)*pi4;
						z1_2[i]=simpson(h,n,z1_2_podint)*pi4;
						z2_1[i]=simpson(h,n,z2_1_podint)*pi4;
						z2_2[i]=simpson(h,n,z2_2_podint)*pi4;
						G_alpha[i]=y1[i]*y2[i];
						G_gamma[i]=z2_1[i]*z1_2[i]+z1_1[i]*z2_2[i];
						h1[i]=simpson(h,n,h1_podint)*pi4;
						h2[i]=simpson(h,n,h2_podint)*pi4;
						G_big_podint[i] = t*t*jjj0(r*t)*(h1[i]*h2[i]+alphaa*G_alpha[i]-gammaa*G_gamma[i]);

					}
					G_bigV[j]=simpson(h,n,G_big_podint)*ccc/2.0/pi/pi;

					v00exV[j]=-1524.25*exp(-4.0*s)/4./s - 518.75*exp(-2.5*s)/2.5/s - 7.8474*exp(-0.7072*s)/0.7072/s;

					u0ex_podint[j]=s*s*G_big[j]*jjj0(fun_K(AA1,AA2,ZZ1,ZZ2,r,En,u0d[l]+u0ex[l-1])*s*(AA1+AA2)/AA1/AA2)*v00ex[j];
//		 printf("eddddbVS %f\n", u0ex_podintV[j]);
				}
		free(G_big_podint);
		free (G_alpha); free(G_gamma);
		free (h1); free(h2);free(h1_podint);free(h2_podint);
		free (y1); free(y2);free (y1_podint); free(y2_podint);
		free (z1_1); free(z1_2); free(z2_1); free(z2_2);
		free (z1_1_podint); free(z1_2_podint);free(z2_1_podint); free(z2_2_podint);
	}
	
	
	// ???????????????? U0EX[L] 5.34
	u0ex[l]=simpson(h,n,u0ex_podint)*4.0*pi*(1.0-0.003*En);

// ???????????????? U0EX[L]
	for (ll=0;ll<30;ll++) {
		for (j=0;j<n;j++) {
			s=rmin+h*j;
			u0ex_podint[j]=s*s*G_bigV[j]*jjj0(fun_K(AA1,AA2,ZZ1,ZZ2,r,En,u0d[l]+u0ex[l])*s*(AA1+AA2)/AA1/AA2)*v00exV[j];
			}
		u0ex[l]=simpson(h,n,u0ex_podint)*pi4*(1.0-0.003*En);
		}

	
	}
	
	 
	endtime=omp_get_wtime();
	printf("Work time %f %d sec\n", endtime-starttime, ll); 
// ???????????????????? ?? ????????
	sprintf(str,"dfpot_%d.out",n);
	stream=fopen(str,"w");
	
	

	for (i=0;i<n;i++) {
	r=rmin+h*i;
	fprintf(stream,"%f\t%f\t%f\t%f\n", r, u0d[i], u0ex[i], u0d[i]+u0ex[i]);
	}

	fclose(stream);
	free(rho1);free(rho2);
	free(rho1c);free(rho2c);
	free(rho1t); free(rho2t);
	free(v00d);
	free(u0d);
	
	free(data_fun_rho1); free(data_fun_rho2);
	
	free(d_rho1_d_r); free(d_rho2_d_r);
	free(d2_rho1_d_r2);free(d2_rho2_d_r2);
	free(Kav_a_1); free(Kav_a_2);
	free(Kav_b_1); free(Kav_b_2);
	free (u0ex);free(u0ex_podint);
	free (v00ex);free(v00ex_podint);
	free (G_big);


	free (Kav_a_1V); free(Kav_a_2V);
	free (Kav_b_1V); free(Kav_b_2V);
	free (u0ex_podintV);
	free (G_bigV);
	free (v00exV);
	//---------------------------------------
	return 0;
}
// -------------------- ?????????? ?????????????????? -----------------------
//
//
// SIMPSON function - ?????????? ???????????????? ?????????????? ??????????????????
//
double simpson(double h, int n, double *f)
{
	double s=0.0;
	int i=0;

	
    s = f[0]+4.0000*f[1];
	for (i=2; i<(n-2); i=i+2) {
		s = s+f[i]*2.00+f[i+1]*4.00;
		}
	s = (s+f[n-1])*h/3.00;
	return (s);
}
//
// ?????????????? ?????????????? 0-??????????????
//
double jjj0(double x)
{
	double result;
	result=sin(x)/x;
	return (result);
}
//
// ?????????????? ?????????????? 1-?????????????? ?? ?????????????? (5.28)
//
double jjj1(double x)
{
	double result;
	result=3.0*(sin(x)-x*cos(x))/(x*x*x);
	return (result);
}
//
// ?????????????? ?????????????????? ?????????????????? ????????
//
double fun_rho1(double r_mal)
{
	double r_bol,a_mal,a_bol,rho_0,pi,result;

// added 2.12.2003 for He-6
	double aa,bb,rho_z,rho_n;
//	aa=1.40;
//	bb=2.04;
// end of adds;

// ??-16
//	r_bol=2.624;
//	a_mal=0.404;
//	a_bol=16.0;

	pi=2.0*asin(1.0);

//	rho_0=( a_bol / (4.0/3.0) / pi / pow(r_bol,3) ) * pow((1+pow((pi*a_mal/r_bol),2)),-1);
//	result=rho_0*sinh(r_bol/a_mal)/(cosh(r_bol/a_mal)+cosh(r_mal/a_mal));

// added 2.12.2003 for He-6 
//	rho_z=2*(exp(-pow(r_mal/aa,2))/pow(aa,3))/pow(pi,1.5);
//	rho_n=2*(exp(-pow(r_mal/aa,2))/pow(aa,3) + 2*pow(r_mal/bb,2)*exp(-pow(r_mal/bb,2))/3/pow(bb,3))/pow(pi,1.5);
//	result=rho_z+rho_n;
// end of adds

// added 10.12.2003 for He-6 Gaussian form
//	aa=2.54*2.54*2.0/3.0;
//	bb=sqrt(aa);
//	rho_0=6.0/pow((sqrt(pi)*bb),3);
//	result=rho_0*exp(-pow(r_mal,2)/aa);

//	result=0.4229*exp(-0.7024*r_mal*r_mal);

// He6 COSMA

    aa=1.55;
    bb=2.25;
	result=2.0*(exp(-r_mal*r_mal/aa/aa)/aa/aa/aa)/pow(pi,1.5);
	result=result+2.0*(exp(-r_mal*r_mal/aa/aa)/aa/aa/aa + (2.0/3.0/bb/bb/bb)*(r_mal*r_mal/bb/bb)*exp(-r_mal*r_mal/bb/bb))/pow(pi,1.5);
	return (result);

}
//
// ???????????? ?????????????????? ????????-????????????
//
double fun_rho2(double r_mal)
{

	double r_bol,a_mal,a_bol,rho_0,pi,result,bbb;
// C-12
//	r_bol=2.1545;
//	a_mal=0.425;
//	a_bol=12;
// Ca-40
//	r_bol=3.593;
//	a_mal=0.493;
//	a_bol=40.0;
// Zr-90
//	r_bol=4.779;
//	a_mal=0.661;
//	a_bol=90.0;
//
//	r_bol=4.9;
//	a_mal=0.515;
//	a_bol=90.0;
//	rho_0=0.165;

// Pb-208
//	r_bol=6.557;
//	a_mal=0.515;
//	a_bol=208.0;
//
// Si-28
	r_bol=3.134;
	a_mal=0.477;
	a_bol=28;

	pi=2.0*asin(1.0);

	rho_0=( a_bol / (4.0/3.0) / pi / pow(r_bol,3) ) * pow((1+pow((pi*a_mal/r_bol),2)),-1);
//	rho_0=0.207;
	result=rho_0*sinh(r_bol/a_mal)/(cosh(r_bol/a_mal)+cosh(r_mal/a_mal));

//	result=0.176/(1+exp((r_mal-4.080)/0.515));
	
//	bbb=1.584;
//	result=4.0/pow(pi,1.5)/pow(bbb,3.0);
//	result=result*(1.0+4.0*r_mal*r_mal/3.0/pow(bbb,2.0));
//	result=result*exp(-r_mal*r_mal/pow(bbb,2.0));

	return (result);
}
//
// ?????????????? ?? 5.24
//
double fun_K(double A1, double A2, double Z1, double Z2, double r, double En, double U)
{
	double Rc,Uc,Ecm,plank,result,Unew;
	plank=197.327*197.327;
	Ecm=En*A1*A2/(A1+A2);

	Rc=1.3*(pow(A1, 0.33333)+pow(A2, 0.33333));

	if (Rc > r) {
		Uc=Z1*Z2*1.43996468*(3.0-(r*r)/(Rc*Rc))/2.0/Rc;
		}
	else {
		Uc=Z1*Z2*1.43996468/r;
		}

//	printf("%f\t%f\n",r,Uc);

	if ((Ecm-U-Uc)<0) {Unew=-U;} else {Unew=U;}

	result=sqrt( 2.0*938.0*A1*A2*(Ecm-Unew-Uc)/(A1+A2)/plank );
	return (result);
}
